## scotch 5.1.8a.dfsg

=== src/Makefile ===
## Copyright 2004,2007-2009 ENSEIRB, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION	= 5.1

.PHONY				:	clean	default	install	ptscotch	realclean	required	scotch

default				:	scotch

required			:	Makefile.inc	../bin	../include	../lib

Makefile.inc			:
					@echo "#####################################################################"
			        	@echo "BEFORE COMPILING Scotch OR PT-Scotch, YOU SHOULD HAVE AN APPROPRIATE"
					@echo "Makefile.inc FILE IN THIS DIRECTORY. PLEASE LOOK INTO DIRECTORY"
	        			@echo " ./Make.inc FOR AN EXISTING Makefile.inc FILE THAT FITS YOUR NEED, OR"
		        		@echo "USE THEM AS MODELS IN CASE YOU NEED TO BUILD A NEW ONE FOR YOUR"
		        		@echo "PARTICULAR PLATFORM."
			        	@echo "#####################################################################"
			        	@echo "Then, type \"make scotch\" (default) for the sequential library"
			        	@echo "and software, or \"make ptscotch\" for the parallel library and"
			        	@echo "software."
					@exit 1

include Makefile.inc

prefix		?= "/usr/local"
bindir		?= "$(prefix)/bin"
includedir	?= "$(prefix)/include"
libdir		?= "$(prefix)/lib"
datarootdir	?= "$(prefix)/share"
mandir		?= "$(datarootdir)/man"

../bin				:
					-$(MKDIR) ../bin

../include			:
					-$(MKDIR) ../include

../lib				:
					-$(MKDIR) ../lib

scotch				:	required
					(cd libscotch ;      $(MAKE) VERSION=\"$(VERSION)\" scotch && $(MAKE) install)
					(cd scotch ;         $(MAKE) VERSION=\"$(VERSION)\" scotch && $(MAKE) install)
					(cd libscotchmetis ; $(MAKE)                        scotch && $(MAKE) install)
					(cd esmumps ;        $(MAKE)                        scotch && $(MAKE) install)

ptscotch			:	required
					(cd libscotch ;      $(MAKE) VERSION=\"$(VERSION)\" ptscotch && $(MAKE) ptinstall)
					(cd scotch ;         $(MAKE) VERSION=\"$(VERSION)\" ptscotch && $(MAKE) ptinstall)
					(cd libscotchmetis ; $(MAKE)                        ptscotch && $(MAKE) ptinstall)
					(cd esmumps ;        $(MAKE)                        ptscotch && $(MAKE) ptinstall)

install				:	required
					-$(CP) -f ../include/*scotch*.h $(includedir)
					-$(CP) -f ../lib/*scotch*$(LIB) $(libdir)

clean				:	required
					(cd libscotch ;      $(MAKE) clean)
					(cd scotch ;         $(MAKE) clean)
					(cd libscotchmetis ; $(MAKE) clean)
					(cd esmumps ;        $(MAKE) clean)

realclean			:	required
					(cd libscotch ;      $(MAKE) realclean)
					(cd scotch ;         $(MAKE) realclean)
					(cd libscotchmetis ; $(MAKE) realclean)
					(cd esmumps ;        $(MAKE) realclean)
					-$(RM) ../bin/* ../include/* ../lib/*

=== src/esmumps/Makefile ===
## Copyright 2004,2007-2009 ENSEIRB, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

bindir		= ../../bin
includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) -I$(includedir) -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -I$(includedir) $(<) -o $(@) -L$(libdir) $(LDFLAGS) -L. -l$(ESMUMPSLIB) -l$(SCOTCHLIB) -l$(SCOTCHLIB)errexit

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:	clean
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" SCOTCHLIB=scotch ESMUMPSLIB=esmumps	\
					libesmumps$(LIB)							\
					main_esmumps$(EXE)

ptscotch			:	clean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" "CC=$(CCP)" SCOTCHLIB=ptscotch ESMUMPSLIB=ptesmumps	\
					libesmumps$(LIB)											\
					main_esmumps$(EXE)

install				:
					-$(CP) esmumps.h $(includedir)
					-$(CP) libesmumps$(LIB) $(libdir)

ptinstall			:
					-$(CP) esmumps.h $(includedir)
					-$(CP) libptesmumps$(LIB) $(libdir)

clean				:
					-$(RM) *~ common.h *$(OBJ) lib*$(LIB) main_esmumps$(EXE)

realclean			:	clean

##
##  Todo list.
##

common.h			:	../libscotch/common.h			\
					module.h
					$(CAT) $(^) > $(@)

graph_graph$(OBJ)		:	graph_graph.c				\
					common.h				\
					$(includedir)/$(SCOTCHLIB).h		\
					graph.h

order$(OBJ)			:	order.c					\
					order.h					\
					common.h				\
					graph.h

order_scotch_graph$(OBJ)	:	order_scotch_graph.c			\
					order.h					\
					common.h				\
					graph.h					\
					$(includedir)/$(SCOTCHLIB).h

dof$(OBJ)			:	dof.c					\
					dof.h					\
					common.h				\
					graph.h					\
					$(includedir)/$(SCOTCHLIB).h

symbol$(OBJ)			:	symbol.c				\
					symbol.h				\
					common.h

symbol_fax$(OBJ)		:	symbol_fax.c				\
					common.h				\
					graph.h					\
					symbol.h				\
					order.h					\
					fax.h

symbol_fax_graph$(OBJ)		:	symbol_fax_graph.c			\
					symbol_fax.c				\
					common.h				\
					graph.h					\
					symbol.h				\
					order.h					\
					fax.h					\
					$(includedir)/$(SCOTCHLIB).h

esmumps$(OBJ)			:	esmumps.c				\
					common.h				\
					graph.h					\
					symbol.h				\
					order.h					\
					fax.h					\
					esmumps.h				\
					$(includedir)/$(SCOTCHLIB).h

esmumps_f$(OBJ)			:	esmumps_f.c				\
					common.h				\
					esmumps.h

esmumps_strats$(OBJ)		:	esmumps_strats.c			\
					common.h				\
					esmumps.h

libesmumps$(LIB)		:	graph_graph$(OBJ)			\
					order$(OBJ)				\
					order_scotch_graph$(OBJ)		\
					dof$(OBJ)				\
					symbol$(OBJ)				\
					symbol_fax_graph$(OBJ)			\
					esmumps$(OBJ)				\
					esmumps_f$(OBJ)				\
					esmumps_strats$(OBJ)
					$(AR) $(ARFLAGS) lib$(ESMUMPSLIB)$(LIB) $(?)
					-$(RANLIB) lib$(ESMUMPSLIB)$(LIB)

main_esmumps$(EXE)		:	main_esmumps.c				\
					common.h				\
					graph.h					\
					order.h					\
					symbol.h				\
					esmumps.h				\
					lib$(ESMUMPSLIB)$(LIB)			\
					$(libdir)/lib$(SCOTCHLIB)$(LIB)		\
					$(libdir)/lib$(SCOTCHLIB)errexit$(LIB)

=== src/libscotch/Makefile ===
## Copyright 2004,2007-2009 ENSEIRB, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -DSCOTCH_VERSION=\"$(VERSION)\" $(<) -o $(@) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:	clean
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" SCOTCHLIB=scotch	\
					scotch.h						\
					scotchf.h						\
					libscotch$(LIB)						\
					libscotcherr$(LIB)					\
					libscotcherrexit$(LIB)

ptscotch			:	clean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIB=ptscotch	\
					scotch.h									\
					scotchf.h									\
					libptscotch$(LIB)								\
					libscotch$(LIB)									\
					libptscotcherr$(LIB)								\
					libptscotcherrexit$(LIB)

install				:
					-$(CP) scotch.h scotchf.h $(includedir)
					-$(CP) libscotch$(LIB) libscotcherr*$(LIB) $(libdir)

ptinstall			:
					-$(CP) scotch.h $(includedir)/ptscotch.h
					-$(CP) scotchf.h $(includedir)/ptscotchf.h
					-$(CP) libptscotch*$(LIB) $(libdir)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB) common2* parser_yy.c parser_ly.h parser_ll.c *scotch.h *scotchf.h y.output dummysizes$(EXE)

realclean			:	clean

##
##  Todo list.
##

common$(OBJ)			:	common.c				\
					module.h				\
					common.h
					$(CAT) module.h common.c > common2.c
					$(CC) $(CFLAGS) -c common2.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common2.c

common_file$(OBJ)		:	common_file.c				\
					module.h				\
					common.h				\
					common_file.h
					$(CAT) module.h common_file.c > common2_file.c
					$(CC) $(CFLAGS) -c common2_file.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common2_file.c

common_file_compress$(OBJ)	:	common_file_compress.c			\
					module.h				\
					common.h				\
					common_file.h				\
					common_file_compress.h
					$(CAT) module.h common_file_compress.c > common2_file_compress.c
					$(CC) $(CFLAGS) -c common2_file_compress.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common2_file_compress.c

common_file_uncompress$(OBJ)	:	common_file_uncompress.c		\
					module.h				\
					common.h				\
					common_file.h				\
					common_file_compress.h
					$(CAT) module.h common_file_uncompress.c > common2_file_uncompress.c
					$(CC) $(CFLAGS) -c common2_file_uncompress.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common2_file_uncompress.c

common_integer$(OBJ)		:	common_integer.c			\
					module.h				\
					common.h				\
					common_sort.c
					$(CAT) module.h common_integer.c > common2_integer.c
					$(CC) $(CFLAGS) -c common2_integer.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common2_integer.c

common_memory$(OBJ)		:	common_memory.c				\
					module.h				\
					common.h
					$(CAT) module.h common_memory.c > common2_memory.c
					$(CC) $(CFLAGS) -c common2_memory.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common2_memory.c

common_stub$(OBJ)		:	common_stub.c				\
					module.h				\
					common.h
					$(CAT) module.h common_stub.c > common_stub2.c
					$(CC) $(CFLAGS) -c common_stub2.c -DSCOTCH_COMMON_RENAME -o $(@)
					$(RM) common_stub2.c

arch$(OBJ)			:	arch.c					\
					module.h				\
					common.h				\
					arch.h					\
					arch_cmplt.h				\
					arch_cmpltw.h				\
					arch_deco.h				\
					arch_hcub.h				\
					arch_mesh.h				\
					arch_tleaf.h				\
					arch_torus.h				\
					arch_vcmplt.h				\
					arch_vhcub.h

arch_build$(OBJ)		:	arch_build.c				\
					module.h				\
					common.h				\
					parser.h				\
					graph.h					\
					arch.h					\
					arch_deco.h				\
					bgraph.h				\
					bgraph_bipart_st.h			\
					arch_build.h

arch_cmplt$(OBJ)		:	arch_cmplt.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_cmplt.h

arch_cmpltw$(OBJ)		:	arch_cmpltw.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_cmpltw.h

arch_deco$(OBJ)			:	arch_deco.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_deco.h

arch_hcub$(OBJ)			:	arch_hcub.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_hcub.h

arch_mesh$(OBJ)			:	arch_mesh.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_mesh.h

arch_tleaf$(OBJ)		:	arch_tleaf.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_tleaf.h

arch_torus$(OBJ)		:	arch_torus.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_torus.h

arch_vcpmlt$(OBJ)		:	arch_vcmplt.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_vcmplt.h

arch_vhcub$(OBJ)		:	arch_vhcub.c				\
					module.h				\
					common.h				\
					arch.h					\
					arch_vhcub.h

bdgraph$(OBJ)			:	bdgraph.c				\
					module.h				\
					common.h				\
					arch.h					\
					dgraph.h				\
					dmapping.h				\
					bdgraph.h

bdgraph_bipart_bd$(OBJ)		:	bdgraph_bipart_bd.c			\
					module.h				\
					common.h				\
					parser.h				\
					arch.h					\
					dgraph.h				\
					dgraph_halo.h				\
					bdgraph.h				\
					bdgraph_bipart_bd.h			\
					bdgraph_bipart_st.h

bdgraph_bipart_df$(OBJ)		:	bdgraph_bipart_df.c			\
					module.h				\
					common.h				\
					parser.h				\
					arch.h					\
					dgraph.h				\
					bdgraph.h				\
					bdgraph_bipart_df.h

bdgraph_bipart_ml$(OBJ)		:	bdgraph_bipart_ml.c			\
					module.h				\
					common.h				\
					parser.h				\
					arch.h					\
					dgraph.h				\
					dgraph_coarsen.h			\
					bdgraph.h				\
					bdgraph_bipart_ml.h			\
					bdgraph_bipart_st.h

bdgraph_bipart_sq$(OBJ)		:	bdgraph_bipart_sq.c			\
					module.h				\
					common.h				\
					parser.h				\
					arch.h					\
					graph.h					\
					bgraph.h				\
					bgraph_bipart_st.h			\
					dgraph.h				\
					bdgraph.h				\
					bdgraph_bipart_sq.h

bdgraph_bipart_st$(OBJ)		:	bdgraph_bipart_st.c			\
					module.h				\
					common.h				\
					gain.h					\
					parser.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_st.h			\
					dgraph.h				\
					dgraph_coarsen.h			\
					bdgraph.h				\
					bdgraph_bipart_bd.h			\
					bdgraph_bipart_df.h			\
					bdgraph_bipart_ml.h			\
					bdgraph_bipart_sq.h			\
					bdgraph_bipart_st.h			\
					bdgraph_bipart_zr.h

bdgraph_bipart_zr$(OBJ)		:	bdgraph_bipart_zr.c			\
					module.h				\
					common.h				\
					arch.h					\
					dgraph.h				\
					bdgraph.h				\
					bdgraph_bipart_zr.h

bdgraph_check$(OBJ)		:	bdgraph_check.c				\
					module.h				\
					common.h				\
					arch.h					\
					dgraph.h				\
					bdgraph.h

bdgraph_gather_all$(OBJ)	:	bdgraph_gather_all.c			\
					module.h				\
					common.h				\
					arch.h					\
					graph.h					\
					bgraph.h				\
					dgraph.h				\
					bdgraph.h

bdgraph_store$(OBJ)		:	bdgraph_store.c				\
					module.h				\
					common.h				\
					arch.h					\
					dgraph.h				\
					bdgraph.h

bgraph$(OBJ)			:	bgraph.c				\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					mapping.h				\
					bgraph.h

bgraph_check$(OBJ)		:	bgraph_check.c				\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h

bgraph_bipart_bd$(OBJ)		:	bgraph_bipart_bd.c			\
					module.h				\
					common.h				\
					parser.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_bd.h			\
					bgraph_bipart_st.h

bgraph_bipart_df$(OBJ)		:	bgraph_bipart_df.c			\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_df.h

bgraph_bipart_ex$(OBJ)		:	bgraph_bipart_ex.c			\
					module.h				\
					common.h				\
					gain.h					\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_ex.h			\
					bgraph_bipart_fm.h			\
					bgraph_bipart_gg.h

bgraph_bipart_fm$(OBJ)		:	bgraph_bipart_fm.c			\
					gain.h					\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_fm.h

bgraph_bipart_gg$(OBJ)		:	bgraph_bipart_gg.c			\
					gain.h					\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_gg.h

bgraph_bipart_gp$(OBJ)		:	bgraph_bipart_gp.c			\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_gp.h

bgraph_bipart_ml$(OBJ)		:	bgraph_bipart_ml.c			\
					module.h				\
					common.h				\
					parser.h				\
					graph.h					\
					graph_coarsen.h				\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_ml.h			\
					bgraph_bipart_st.h

bgraph_bipart_st$(OBJ)		:	bgraph_bipart_st.c			\
					gain.h					\
					module.h				\
					common.h				\
					parser.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_bd.h			\
					bgraph_bipart_df.h			\
					bgraph_bipart_ex.h			\
					bgraph_bipart_fm.h			\
					bgraph_bipart_gg.h			\
					bgraph_bipart_gp.h			\
					bgraph_bipart_ml.h			\
					bgraph_bipart_st.h			\
					bgraph_bipart_zr.h

bgraph_bipart_zr$(OBJ)		:	bgraph_bipart_zr.c			\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h				\
					bgraph_bipart_zr.h

bgraph_store$(OBJ)		:	bgraph_store.c				\
					module.h				\
					common.h				\
					graph.h					\
					arch.h					\
					bgraph.h

dgraph$(OBJ)			:	dgraph.c				\
					module.h				\
					common.h				\
					dgraph.h

dgraph_allreduce$(OBJ)		:	dgraph_allreduce.c			\
					module.h				\
					common.h				\
					dgraph.h

dgraph_band$(OBJ)		:	dgraph_band.c				\
					module.h				\
					common.h				\
					dgraph.h

dgraph_build$(OBJ)		:	dgraph_build.c				\
					module.h				\
					common.h				\
					dgraph.h				\
					dgraph_allreduce.h			\
					dgraph_build.h

dgraph_build_grid3d$(OBJ)	:	dgraph_build_grid3d.c			\
					module.h				\
					common.h				\
					dgraph.h

dgraph_build_hcub$(OBJ)		:	dgraph_build_hcub.c			\
					module.h				\
					common.h				\
					dgraph.h

dgraph_check$(OBJ)		:	dgraph_check.c				\
					module.h				\
					common.h				\
					dgraph.h

dgraph_coarsen$(OBJ)		:	dgraph_coarsen.c			\
					module.h				\
					common.h				\
					dgraph.h				\
					dgraph_allreduce.h			\
					dgraph_coarsen.h			\
					dgraph_match.h

dgraph_fold$(OBJ)		:	dgraph_fold.c				\
					module.h				\
					common.h				\
					dgraph.h				\
					dgraph_fold.h				\
					dgraph_fold_comm.h

dgraph_fold_comm$(OBJ)		:	dgraph_fold_comm.c			\
					module.h				\
					common.h				\
					dgraph.h				\

=== src/libscotchmetis/Makefile ===
## Copyright 2007-2009 ENSEIRB, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

bindir		= ../../bin
includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) -I$(includedir) -I../libscotch -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -o $(@) -L$(libdir) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) CC="$(CCS)" SCOTCHLIB=ptscotch						\
					libscotchmetis$(LIB)

ptscotch			:
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIB=ptscotch	\
					libptscotchparmetis$(LIB)

install				:	scotch
					-$(CP) metis.h $(includedir)
					-$(CP) libscotchmetis$(LIB) $(libdir)

ptinstall			:	ptscotch
					-$(CP) parmetis.h $(includedir)
					-$(CP) libptscotchparmetis$(LIB) $(libdir)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB)

realclean			:	clean

##
##  Todo list.
##

metis_graph_order$(OBJ)		:	metis_graph_order.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_order_f$(OBJ)	:	metis_graph_order_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_part$(OBJ)		:	metis_graph_part.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_part_f$(OBJ)	:	metis_graph_part_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

parmetis_dgraph_order$(OBJ)	:	parmetis_dgraph_order.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_order_f$(OBJ)	:	parmetis_dgraph_order_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_part$(OBJ)	:	parmetis_dgraph_part.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_part_f$(OBJ)	:	parmetis_dgraph_part_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

libptscotchparmetis$(LIB)	:	parmetis_dgraph_order$(OBJ)		\
					parmetis_dgraph_order_f$(OBJ)		\
					parmetis_dgraph_part$(OBJ)		\
					parmetis_dgraph_part_f$(OBJ)
					$(AR) $(ARFLAGS) $(@) $(^)
					-$(RANLIB) $(@)

libscotchmetis$(LIB)		:	metis_graph_order$(OBJ)			\
					metis_graph_order_f$(OBJ)		\
					metis_graph_part$(OBJ)			\
					metis_graph_part_f$(OBJ)
					$(AR) $(ARFLAGS) $(@) $(^)
					-$(RANLIB) $(@)

=== debian/changelog ===
scotch (5.1.8a.dfsg-2) unstable; urgency=low

  * Added -I to CCS to fix building with LAM-MPI (closes: #581381).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 19 May 2010 14:21:57 -0400

scotch (5.1.8a.dfsg-1) unstable; urgency=low

  * New upstream.
  * Changed control file to conform to Debian Science Policy Manual.
  * Added -I to CFLAGS to fix building with LAM-MPI (closes: #581381).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 12 May 2010 11:33:16 -0400

scotch (5.1.7.dfsg-5) unstable; urgency=low

  * Fixed debugging packages for libraries, and added debugging packages for
    executables in scotch and ptscotch.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 06 Apr 2010 07:34:40 -0400

scotch (5.1.7.dfsg-4) unstable; urgency=low

  [Christophe Trophime]
  * Fix lintian warning
  * Add remove esmumps .so and .a in clean target in debian/rules
  * Add remove [p]scotch-esmumps in clean target in debian/rules
  * Add missing ptscotch headers in libptscotch-dev (closes: #576280).

  [Adam C. Powell, IV]
  * Added -I/usr/include/lam to Makefile.inc (closes: #574724).
  
 -- Adam C. Powell, IV <hazelsct@debian.org>  Sun, 04 Apr 2010 22:40:02 -0400

scotch (5.1.7.dfsg-3) unstable; urgency=low

  * Uses chrpath to remove rpath from ptscotch and libptscotch5.1 binaries.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Mon, 15 Mar 2010 16:25:41 -0400

scotch (5.1.7.dfsg-2) unstable; urgency=low

  * libscotchmetis-dev conflicts with libparmetis-dev (closes: #568841).
  * Made package descriptions more descriptive (closes: #568819, #572892).
  * Added MPI include to library.h included in scotch.h (closes: #570097).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Mon, 15 Mar 2010 15:10:03 -0400

scotch (5.1.7.dfsg-1) unstable; urgency=low

  [Christophe Trophime]
  * New upstream release.
  * Added PT-scotch support (Closes: #561384).

  [Adam C. Powell, IV]
  * Removed headers from libptscotch-dev, made it depend on libscotch-dev.
  * Using version with esmumps subdirectory (closes: #531048).
  * Changed source format to 3.0 (quilt).
  * Bumped Standards-Version.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 02 Feb 2010 20:03:23 -0500

scotch (5.1.6.dfsg-3) unstable; urgency=low

  [Christophe Prud'homme]
  * Bug fix: "FTBFS with binutils-gold", thanks to Peter Fritzsche
    (Closes: #556338).
  * Bug fix: "Should be arch: all", thanks to Adam C Powell IV (Closes:
    #496701).

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 14 Dec 2009 07:31:38 +0100

scotch (5.1.6.dfsg-2) unstable; urgency=low

  * Bug fix: "Should be arch: all", thanks to Adam C Powell IV (Closes:
    #496701).

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 26 May 2009 08:32:26 +0200

scotch (5.1.6.dfsg-1) unstable; urgency=low

  * New upstream release
   + This is mainly a bugfix revision. A bug in the graph folding code,
    which was almost silent in previous releases, was not fixed in release
    5.1.5 but instead was made more salient. It is now fixed for good.
   + A new feature has beed added to the API, which allows users to
    perform asynchronous halo exchange operations, whenever available.

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 21 May 2009 22:36:28 +0200

scotch (5.1.4.dfsg-2) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/genmanpage.sh: fixed project home page in man pages and
    regenerated the man pages.

  [Adam C. Powell, IV]
  * Updated version number in patches/shared-libs.patch and shared lib package
    .install file name (closes: #527617).
  * Fixed my name in control to match my key (generates an erroneous lintian
    warning, see bug 485705).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Fri, 08 May 2009 10:37:25 -0400

scotch (5.1.4.dfsg-1) unstable; urgency=low

  [Christophe Prud'homme]
  * New upstream release
  * debian/rules: rename rule orig-tarball by standard rule
    get-orig-source
  * debian/rules: automatically find out about upstream
  * debian/control: update Standards-Version to 3.8.1 (no change)
  * debian/control: added -dbg
  * debian/control: now generate libscotch-5.1 instead of libscotch-5.1.x,
    don't use the minor version x, there is no interface change
  * scotch: provide script to generate 'dummy' manpages for executables
  * fixed lintian warnings and errors

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 16 Apr 2009 10:58:47 +0200

scotch (5.0.6.dfsg-3) unstable; urgency=low

  * Patched metis.h to include typedef idxtype (closes: #496693).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 26 Aug 2008 15:26:16 -0400

scotch (5.0.6.dfsg-2) unstable; urgency=low

  * First upload in a long time (closes: #470419, #470420).
  * Added shared libraries (closes: #470422).
  * Added quilt (for shlib patch) and zlib1g-dev Build-Deps.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Mon, 21 Jul 2008 12:16:35 -0400

scotch (5.0.6.dfsg-1) unstable; urgency=low

  * New upstream release
  * Update Standards-Version to 3.8.0, no changes

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 01 Jul 2008 08:08:45 +0200

scotch (5.0.5.dfsg-1) unstable; urgency=low

  [ Christophe Prud'homme ]
  * New upstream release
  * Bug fix: "scotch: new upstream available", thanks to Adam C Powell IV
    (Closes: #470420).
  * Bug fix: "scotch: lintian cleanups", thanks to Adam C Powell IV
    (Closes: #470419).

  [ Daniel Leidert ]
  * debian/control: Added Vcs and Homepage fields.
  * debian/watch: Fixed.

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 11 Mar 2008 06:52:06 +0100

scotch (5.0.1.dfsg-1) unstable; urgency=low

  * Initial Debian package (Closes: #462487).

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 25 Jan 2008 09:13:53 +0100

=== debian/control ===
Source: scotch
Section: math
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, "Adam C. Powell, IV" <hazelsct@debian.org>
DM-Upload-Allowed: yes
Build-Depends: cdbs, debhelper (>= 7), bison, flex, zlib1g-dev, chrpath,
 mpi-default-dev, mpi-default-bin
Standards-Version: 3.8.4.0
Vcs-Git: git://git.debian.org/git/debian-science/packages/scotch.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/scotch.git
Homepage: http://www.labri.fr/perso/pelegrin/scotch/

Package: scotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Its purpose is to apply graph theory, with a divide and conquer
 approach, to scientific computing problems such as graph and mesh
 partitioning, static mapping, and sparse matrix ordering, in
 application domains ranging from structural mechanics to operating
 systems or bio-chemistry.
 .
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 SCOTCH has many interesting features:
 .
 o Its capabilities can be used through a set of stand-alone programs
 as well as through the libSCOTCH library, which offers both C and
 Fortran interfaces.
 .
 o It provides algorithms to partition graph structures, as well as
 mesh structures defined as node-element bipartite graphs and which
 can also represent hypergraphs.
 .
 o It can map any weighted source graph onto any weighted target
 graph. The source and target graphs may have any topology, and their
 vertices and edges may be weighted. Moreover, both source and target
 graphs may be disconnected. This feature allows for the mapping of
 programs onto disconnected subparts of a parallel architecture made
 up of heterogeneous processors and communication links.
 .
 o It computes amalgamated block orderings of sparse matrices, for
 efficient solving using BLAS routines.
 .
 o Its running time is linear in the number of edges of the source
 graph, and logarithmic in the number of vertices of the target graph
 for mapping computations.
 .
 o It can handle indifferently graph and mesh data structures created
 within C or Fortran programs, with array indices starting from 0 or
 1.
 .
 o It offers extended support for adaptive graphs and meshes through
 the handling of disjoint edge arrays.
 .
 o It is dynamically parametrizable thanks to strategy strings that
 are interpreted at run-time.
 .
 o It uses system memory efficiently, to process large graphs and
 meshes without incurring out-of-memory faults;
 .
 o It is highly modular and documented. Since it has been released
 under the CeCILL-C free/libre software license, it can be used as a
 testbed for the easy and quick development and testing of new
 partitioning and ordering methods.
 .
 o It can be easily interfaced to other programs. The programs
 comprising the SCOTCH project have been designed to run in
 command-line mode without any interactive prompting, so that they can
 be called easily from other programs by means of system() or popen()
 calls, or piped together on a single command line. Moreover, vertex
 labeling capabilities allow for easy renumbering of vertices.
 .
 o It provides many tools to build, check, and display graphs, meshes
 and matrix patterns.
 .
 o It is written in C and uses the POSIX interface, which makes it
 highly portable. PT-SCOTCH uses the MPI interface, and optionally the
 POSIX threads.

Package: ptscotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libscotch-dev
Section: libdevel
Architecture: any
Depends: libscotch-5.1 (= ${binary:Version}), zlib1g-dev, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dev
Section: libdevel
Architecture: any
Depends: libptscotch-5.1 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: scotch-dbg
Section: debug
Architecture: any
Depends: scotch (= ${binary:Version}), zlib1g-dbg, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Debug symbols package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: ptscotch-dbg
Section: debug
Architecture: any
Depends: ptscotch (= ${binary:Version}), zlib1g-dbg, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Debug symbols package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: libscotch-dbg
Section: debug
Architecture: any
Depends: libscotch-5.1 (= ${binary:Version}), zlib1g-dbg, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Debug symbols package for the scotch library, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dbg
Section: debug
Architecture: any
Depends: libptscotch-5.1 (= ${binary:Version}), zlib1g-dbg, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Debug symbols package for the PT-SCOTCH library, the MPI version of scotch,
 which is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: libscotchmetis-dev
Section: libdevel
Architecture: any
Depends: libscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libmetis-dev, libparmetis-dev
Replaces: libmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/Metis compatility interface, providing a free implementation of the
 Metis system for graph partitioning and sparse matrix reordering.

Package: libscotchparmetis-dev
Section: libdevel
Architecture: any
Depends: libptscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libparmetis-dev
Replaces: libparmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/ParMetis compatility interface, providing a free implementation of the
 ParMetis system for parallel graph partitioning and sparse matrix reordering.

Package: libscotch-5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

# Add here any variable or target overrides you need.
# where sources are
DEB_SRCDIR = $(CURDIR)/src

CCP=mpicc
CFLAGS=-g -O3 -I. -fPIC -Drestrict=__restrict -DCOMMON_FILE_COMPRESS_GZ -DCOMMON_PTHREAD -DCOMMON_RANDOM_FIXED_SEED -DSCOTCH_PTHREAD -DSCOTCH_RENAME
LDFLAGS=-lz -lm -lrt

DEB_DBG_PACKAGE_scotch = scotch-dbg
DEB_DBG_PACKAGE_ptscotch = ptscotch-dbg
DEB_DBG_PACKAGE_libscotch-5.1 = libscotch-dbg
DEB_DBG_PACKAGE_libptscotch-5.1 = libptscotch-dbg

configure/scotch::
	cp debian/Makefile.inc src/Makefile.inc
	(cd src/libscotch && make scotch.h scotchf.h)

build/scotch::
	-for i in acpl amk_grf  amk_p2 gbase gmk_hy gmk_msh gord gtst mcv mord\
                 amk_ccc amk_hy atst gcv gmk_m2  gmk_ub2 gotst mmk_m2  mtst\
                 amk_fft2 amk_m2 gmap gmk_m3 gmtst gout mmk_m3;\
        do\
	 mv bin/$$i bin/scotch_$$i;\
	done

build/ptscotch::
	-for i in dgmap dgord dgscat dgpart dgtst;\
        do\
	 mv bin/$$i bin/ptscotch_$$i;\
	 chrpath --delete bin/ptscotch_$$i;\
	done
	chrpath --delete src/esmumps/ptscotch_esmumps

build/libptscotch-5.1::
	chrpath --delete src/libscotch/libptscotch-5.1.so
	chrpath --delete src/libscotch/libptscotcherr-5.1.so
	chrpath --delete src/libscotch/libptscotcherrexit-5.1.so
	chrpath --delete src/esmumps/libptesmumps-5.1.so
	chrpath --delete src/libscotchmetis/libptscotchparmetis-5.1.so

install/libscotchmetis-dev::
	(cd lib && ln -s libscotchmetis.a libmetis.a); \
	(cd src/libscotchmetis/ && ln -s libscotchmetis.so libmetis.so)

install/libscotchparmetis-dev::
	(cd lib && ln -s libptscotchparmetis.a libparmetis.a);
	(cd src/libscotchmetis && ln -s libptscotchparmetis.so libparmetis.so)

clean::
	-cp debian/Makefile.inc src/Makefile.inc
	-rm bin/*
	-rm include/*
	-rm src/Makefile.inc
	-rm src/libscotch/*.so src/libscotch/*.a
	-rm src/esmumps/*.so src/esmumps/*.a
	-rm src/esmumps/*scotch_esmumps
	-rm src/libscotchmetis/*.so src/libscotchmetis/*.a
	-rm lib/*.so lib/*.a

DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')
SCOTCH_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)

get-orig-source:
	mkdir tmp; \
	cd tmp; \
	wget http://gforge.inria.fr/frs/download.php/5218/scotch_$(SCOTCH_VERSION)_esmumps.tar.gz; \
	tar xzf scotch_$(SCOTCH_VERSION)_esmumps.tar.gz; \
	mv scotch_5.1_esmumps scotch-$(SCOTCH_VERSION);\
	cd scotch-$(SCOTCH_VERSION);\
	rm doc/ptscotch_user5.1.pdf doc/scotch_user5.1.ps.gz doc/ptscotch_user5.1.ps.gz  doc/scotch_user5.1.pdf; \
	cd .. ; \
	tar czf ../scotch_$(SCOTCH_VERSION).dfsg.orig.tar.gz scotch-$(SCOTCH_VERSION); \
	cd ..; rm -rf tmp
